#130 udp forwarded packets over slirp have incorrect source ip

v0.7.x (release)
closed-fixed
nobody
None
5
2008-08-19
2008-06-17
No

after upgrading from coLinux 0.7.1 to 0.7.3, my TFTP connection failed. the coLinux setup is:
eth0=slirp,,tcp:22:22/tcp:333:22/tcp:10000:10000/udp:69:69

connecting from an external machine (named "G5") to the windows machine which forwards port 69 (tftp) to the colinux system which is running a tftp server

running tcpdump against 0.7.1 shows:
01:34:47.410000 IP G5.60808 > 10.0.2.15.tftp: 15 RRQ "moo" netascii

running tcpdump against 0.7.3 shows:
01:44:45.645802 IP 10.0.2.2.33431 > 10.0.2.15.tftp: 15 RRQ "moo" netascii

for some reason the forwarded packet had the source IP changed from the real external machine (G5) to the windows' side of the slirp tunnel (10.0.2.2). this means the tftp server then attempts to reply to "10.0.2.2" instead of "G5" and things obviously fail.

merely replacing 'colinux-slirp-net-daemon.exe' in 0.7.3 with the version from 0.7.1 allows things to work as expected under 0.7.3

tcp forwarded packets work with both versions though, so it seems like a udp-specific issue ?

Discussion

  • Henry N.

    Henry N. - 2008-06-27
    • milestone: --> v0.7.x (release)
    • status: open --> closed-fixed
     
  • Henry N.

    Henry N. - 2008-06-27

    Logged In: YES
    user_id=579204
    Originator: NO

    Some lines in source was missing to change between SVN revisions 479 and 480, you have mailed me. Many thanks for your details.

    Bug has been fixed in SVN revision 1060 (stable) and 1061 (devel) now.

    An update colinux-slirp-net-daemon-0.7.3-2.zip is available from SF file releases:
    http://downloads.sourceforge.net/colinux/coLinux-0.7.2-src.tar.gz?download

     
  • Henry N.

    Henry N. - 2008-08-17
    • status: closed-fixed --> open-fixed
     
  • Mike Frysinger

    Mike Frysinger - 2008-08-19

    Logged In: YES
    user_id=114429
    Originator: YES

    my udp tftp server still works with that version

     
  • Henry N.

    Henry N. - 2008-08-19
    • status: open-fixed --> closed-fixed
     
  • Henry N.

    Henry N. - 2008-08-19

    Logged In: YES
    user_id=579204
    Originator: NO

    OK, thanks.
    Changes are in SVN revision 1112 (devel) and 1113 (stable) now.

     

Get latest updates about Open Source Projects, Conferences and News.

Sign up for the SourceForge newsletter:





No, thanks